Name:           nominatim
Version:        2.5.1
Release:        1%{?dist}
Summary:        Open Source search based on OpenStreetMap data
License:        GPLv2
URL:            https://github.com/openstreetmap/Nominatim
Source0:        http://www.nominatim.org/release/Nominatim-%{version}.tar.bz2
Patch0:         nominatim-ax_pthread.patch
Patch1:         nominatim-exclude-osm2pgsql.patch
Patch2:         nominatim-fix-bin-and-lib-dirs.patch
Patch3:         nominatim-settings-el7.patch
Patch4:         nominatim-settings-fedora.patch
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  make
BuildRequires:  libtool
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libxml2-devel
BuildRequires:  geos-devel
BuildRequires:  proj-devel
BuildRequires:  postgresql-devel
BuildRequires:  bzip2-devel
BuildRequires:  boost-devel
BuildRequires:  expat-devel
BuildRequires:  zlib-devel
BuildRequires:  libpqxx-devel
Requires:       proj-epsg
Requires:       php-pgsql
Requires:       php-pear
Requires:       php-pear-DB
Requires:       policycoreutils-python
Requires:       osm2pgsql
Requires:       %{name}-data
BuildRequires:  tree

%description
Nominatim (from the Latin, 'by name') is a tool to search OpenStreetMap data
by name and address (geocoding) and to generate synthetic addresses of OSM
points (reverse geocoding). An instance with up-to-date data can be found
at http://nominatim.openstreetmap.org. Nominatim is also used as one of the
sources for the Search box on the OpenStreetMap home page and powers the
search on the MapQuest Open Initiative websites.

%package data
Summary:        Database dumps for nominatim
BuildArch:      noarch

%description data
This is the big database dumps embedded in sources for nominatim

%prep
%setup -qn Nominatim-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%if 0%{?rhel} == 7
%patch3 -p1
%else
%patch4 -p1
%endif
./autogen.sh

%build
%{configure} 
make %{?_smp_mflags}
for file in sql/functions.sql utils/setup.php
do
    sed -i -e '/nominatim.so/ s;@LIBDIR@;%{_libdir};g' ${file}
done

%install
%{__mkdir_p} %{buildroot}%{_bindir}
%{__mkdir_p} %{buildroot}%{_libdir}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{name}
%{__mkdir_p} %{buildroot}%{_datadir}/%{name}
%{__mkdir_p} %{buildroot}%{_localstatedir}/lib/%{name}
%{__install} -m 0755 nominatim/nominatim %{buildroot}%{_bindir}/nominatim
%{__install} -m 0755 module/nominatim.so %{buildroot}%{_libdir}/nominatim.so
for dir in contrib lib sql utils website wikidata
do
    %{__cp} -r ${dir} %{buildroot}%{_datadir}/%{name}/${dir}
done
%{__cp} -r data/* %{buildroot}%{_localstatedir}/lib/%{name}/
%{__cp} -r settings/* %{buildroot}%{_sysconfdir}/%{name}/
ln -s %{_localstatedir}/lib/%{name} %{buildroot}%{_datadir}/%{name}/data
ln -s %{_sysconfdir}/%{name} %{buildroot}%{_datadir}/%{name}/settings

%pre
getent group nominatim > /dev/null || groupadd -r nominatim
getent passwd nominatim > /dev/null || useradd -r -g nominatim -c "Nominatim User" -s /sbin/nologin -d /var/lib/nominatim nominatim

%post
/usr/sbin/ldconfig
echo "You may want to download additional data for nominatim"
echo "curl -fS -o /var/lib/nominatim/wikipedia_article.sql.bin http://www.nominatim.org/data/wikipedia_article.sql.bin"
echo "curl -fS -o /var/lib/nominatim/wikipedia_redirect.sql.bin http://www.nominatim.org/data/wikipedia_redirect.sql.bin"
echo "curl -fS -o /var/lib/nominatim/gb_postcode_data.sql.gz http://www.nominatim.org/data/gb_postcode_data.sql.gz"

%postun
/usr/sbin/ldconfig

%files
%doc AUTHORS ChangeLog NEWS phpunit.xml README VAGRANT.md Vagrantfile vagrant mysql2pgsql
%license COPYING
%{_bindir}/nominatim
%{_libdir}/nominatim.so
%{_datadir}/%{name}
%attr(0755,nominatim,nominatim) %dir %{_localstatedir}/lib/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/settings.php
%config %{_sysconfdir}/%{name}/partitionedtags.def
%config %{_sysconfdir}/%{name}/phrase_settings.php

%files data
%{_localstatedir}/lib/%{name}/*

%changelog
* Thu Jun 22 2017 Didier Fabert <didier.fabert@gmail.com> 2.5.1-1
- First Release

